import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _extends from "@babel/runtime/helpers/esm/extends";
import React, { useContext } from "react";
import hoistNonReactStatics from "hoist-non-react-statics";
import { getDisplayName } from "./utils";
import { StoreManager } from "./context";
import { useModel } from "./hooks";
export var connect = function connect(selectors, actions) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (Component) {
    var pure = typeof options.pure === "boolean" ? options.pure : true;
    var forwardRef = options.forwardRef;
    var WrappedComponent = typeof Component === "function" && pure ? React.memo(Component) : Component;
    var ConnectComponent = React.memo(function (props) {
      var context = useContext(StoreManager);
      var modelProps = useModel(selectors, actions, props);
      var dom =
      /*#__PURE__*/
      React.createElement(WrappedComponent, _extends({}, props, modelProps));
      return (
        /*#__PURE__*/
        React.createElement(StoreManager.Provider, {
          value: _objectSpread({}, context, {
            instanceId: modelProps.instanceId,
            renderLevel: context.renderLevel + 1
          })
        }, dom)
      );
    });
    var Connect = ConnectComponent;

    if (forwardRef) {
      Connect = React.forwardRef(function (props, ref) {
        return (
          /*#__PURE__*/
          React.createElement(ConnectComponent, _extends({}, props, {
            reduxMVCForwardedRef: ref
          }))
        );
      });
    }

    Connect.displayName = "WithReduxMVCConnect(".concat(getDisplayName(WrappedComponent), ")");
    return hoistNonReactStatics(Connect, WrappedComponent);
  };
};