"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  DEFAULT_INSTANCE_ID: true,
  GLOBAL_CONTEXT_ID: true,
  createModel: true,
  createContext: true,
  connect: true,
  useModel: true,
  createSelector: true,
  StoreManager: true
};
Object.defineProperty(exports, "DEFAULT_INSTANCE_ID", {
  enumerable: true,
  get: function get() {
    return _constants.DEFAULT_INSTANCE_ID;
  }
});
Object.defineProperty(exports, "GLOBAL_CONTEXT_ID", {
  enumerable: true,
  get: function get() {
    return _constants.GLOBAL_CONTEXT_ID;
  }
});
Object.defineProperty(exports, "createModel", {
  enumerable: true,
  get: function get() {
    return _model.createModel;
  }
});
Object.defineProperty(exports, "createContext", {
  enumerable: true,
  get: function get() {
    return _providers.createContext;
  }
});
Object.defineProperty(exports, "connect", {
  enumerable: true,
  get: function get() {
    return _consumers.connect;
  }
});
Object.defineProperty(exports, "useModel", {
  enumerable: true,
  get: function get() {
    return _hooks.useModel;
  }
});
Object.defineProperty(exports, "createSelector", {
  enumerable: true,
  get: function get() {
    return _selectors.createSelector;
  }
});
Object.defineProperty(exports, "StoreManager", {
  enumerable: true,
  get: function get() {
    return _context.StoreManager;
  }
});

var _constants = require("./constants");

var _decorators = require("./decorators");

Object.keys(_decorators).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _decorators[key];
    }
  });
});

var _interface = require("./interface");

Object.keys(_interface).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _interface[key];
    }
  });
});

var _model = require("./model");

var _providers = require("./providers");

var _consumers = require("./consumers");

var _hooks = require("./hooks");

var _selectors = require("./selectors");

var _context = require("./context");