"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createContext = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _utils = require("./utils");

var _context = require("./context");

var _constants = require("./constants");

var createContext = function createContext(_ref) {
  var module = _ref.module,
      _ref$contextId = _ref.contextId,
      contextId = _ref$contextId === void 0 ? Symbol("MVCContextId") : _ref$contextId,
      options = (0, _objectWithoutProperties2["default"])(_ref, ["module", "contextId"]);
  return function (WrappedComponent) {
    var WithReduxMVCContext =
    /*#__PURE__*/
    function (_Component) {
      (0, _inherits2["default"])(WithReduxMVCContext, _Component);

      function WithReduxMVCContext(props, context) {
        var _this;

        (0, _classCallCheck2["default"])(this, WithReduxMVCContext);
        _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(WithReduxMVCContext).call(this, props, context));
        context.moduleInstances[contextId] = context.moduleInstances[contextId] || (0, _objectSpread2["default"])({}, module);

        _this.callLifeCycle("constructor");

        return _this;
      }

      (0, _createClass2["default"])(WithReduxMVCContext, [{
        key: "updateModuleInstance",
        value: function updateModuleInstance(moduleInstance) {
          if (moduleInstance) {
            this.context.moduleInstances[contextId] = moduleInstance;
            this.store = moduleInstance.store;
          }
        }
      }, {
        key: "lifeCycleExists",
        value: function lifeCycleExists(name, module) {
          return typeof module[name] === "function";
        }
      }, {
        key: "callLifeCycle",
        value: function callLifeCycle(name) {
          var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

          if (this.lifeCycleExists(name, module)) {
            this.updateModuleInstance(module[name].call(this, (0, _objectSpread2["default"])({
              moduleInstances: this.context.moduleInstances,
              contextId: contextId
            }, options, {}, params)));
          }
        }
      }, {
        key: "componentDidCatch",
        value: function componentDidCatch(error, info) {
          this.callLifeCycle("componentDidCatch", {
            error: error,
            info: info
          });
        }
      }, {
        key: "componentDidMount",
        value: function componentDidMount() {
          this.callLifeCycle("componentDidMount");
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.callLifeCycle("componentWillUnmount");
        }
      }, {
        key: "render",
        value: function render() {
          var instanceId = this.props.instanceId || _constants.DEFAULT_INSTANCE_ID;
          return (
            /*#__PURE__*/
            _react["default"].createElement(_context.StoreManager.Provider, {
              value: (0, _objectSpread2["default"])({}, this.context, {
                contextId: contextId,
                instanceId: instanceId,
                renderLevel: 0
              })
            },
            /*#__PURE__*/
            _react["default"].createElement(WrappedComponent, (0, _extends2["default"])({}, this.props, {
              instanceId: instanceId
            })))
          );
        }
      }]);
      return WithReduxMVCContext;
    }(_react.Component);

    WithReduxMVCContext.contextType = _context.StoreManager;
    WithReduxMVCContext.displayName = "WithReduxMVCContext(".concat((0, _utils.getDisplayName)(WrappedComponent), ")");
    return WithReduxMVCContext;
  };
};

exports.createContext = createContext;